checkRequire("Lua_Itemlist");
checkRequire("Lua_LeaderBoardData");
Lua_LeaderBoardPanel = class("Lua_LeaderBoardPanel", Lua_DisplayObject);
function Lua_LeaderBoardPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_LeaderBoardPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.isLeaderShow = UICreate.createUIAtlasImage(self.content, "leaderBoard_atlas", "ui_paihang_font_1", 354, 0, 182, 32);
	self.isLeaderShow:setDepth(11);
	
	self.itemDragList = Lua_DragList.new(self.content,1, Vector4(0, 0, 535, 474));
	self.itemDragList:setListCell(Lua_Itemlist, 88, 535, 1);
	self.itemDragList:setLocation(348, -30, 0);
	
	self:addLuaEvent("LEADERBOARD_UPDATE", self, self.leaderboardUpdata)
	self:addLuaEvent("ItemCellClickinfo", self, self.itemCellClickinfo);
end

function Lua_LeaderBoardPanel:leaderboardUpdata()
	local rankArr = DataCenter.LeaderBoardData.rankArr;
	self.itemDragList:setLuaArrayData(rankArr, false);
	self.itemDragList:moveToIndex(1, true);
	self.itemDragList:setSelected(1);

	self:itemCellClickinfo(rankArr[1]);
end

function Lua_LeaderBoardPanel:itemCellClickinfo(data)
	if data == nil then
		self.isLeaderShow:setEnable(true);

		DataCenter.LeaderBoardData.isLeaderShow = true;
		Lua_MsgUtil.callFunc("ONELEADERBOARD_INFO", DataCenter.LeaderBoardData.isLeaderShow);
	else
		self.isLeaderShow:setEnable(false);

		DataCenter.LeaderBoardData.isLeaderShow = false;
		DataCenter.LeaderBoardData:oneleaderBoard(data.roleid, DataCenter.LeaderBoardData.ranktype, data.sort);
	end
end

function Lua_LeaderBoardPanel:dispose()
	if self.isLeaderShow ~= nil then
		self.isLeaderShow:dispose();
		self.isLeaderShow = nil;
	end
	if self.itemDragList ~= nil then
		self.itemDragList:dispose();
		self.itemDragList = nil;
	end
	
	self:superCall("dispose");
end