checkRequire("Lua_LeaderBoardPanel");
checkRequire("Lua_LeaderBoardVo");
checkRequire("Lua_MyPlayerModel");
Lua_LeaderBoardWindow = class("Lua_LeaderBoardWindow", Lua_FullSizeWindow);
function Lua_LeaderBoardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_LeaderBoardWindow";
	self.skinName = "LeaderBoardWindow_skin";
	self.bgPath = "/images/common/ui_common_bg.jpg";
end

function Lua_LeaderBoardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:setShowTitle("titleName_altas_1", "paihang");

	self:addLuaEvent("ON_LEADERBOARD_ITEM_CLICK", self, self.updateLeaderBoardPanelInfo);
	self:addLuaEvent("ONELEADERBOARD_INFO", self, self.oneLeaderboardInfo);
	self:addLuaEvent("ONELEADERBOARD_UPDATE", self, self.oneLeaderboardInfo);

	self.zhanli = Lua_NumberImage.new(self.content);
	self.zhanli.numAtlas = "number_atlas";
	self.zhanli.numWidth = 11.5;
	self.zhanli:setDepth(4)
	self.zhanli:setLocation(-128, 198.5);

	self.vipIcon = UICreate.createUIAtlasImage(self.content, "leaderBoard_atlas", "ui_common_z_vip2", 213, -299, 0, 0);
	self.vipIcon:setDepth(5);
	self.vipIcon:setEnable(false);

	self.vipNum = Lua_NumberImage.new(self.content);
	self.vipNum.prefix = "fvip_";
	self.vipNum.numWidth = 13;
	self.vipNum:setDepth(6);
	self.vipNum:setLocation(243, -299, 0);

	local vo;
	self.btnInfos = Array();
	for i = 1, 17 do
		vo = Lua_LeaderBoardVo.new(i)
		self.btnInfos:add({sort = i, name = vo.name, titleone = vo.titleone,
			titletwo = vo.titletwo, titlethree = vo.titlethree});
	end
	self.btnList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 220, 586));
	self.btnList:setListCell(Lua_btnListItem, 69, 212, 1);
	self.btnList:setLocation(-497, -38, 0);
	self.btnList:setLuaArrayData(self.btnInfos, false);

	self:updateLeaderBoardPanelInfo(1);
end

function Lua_LeaderBoardWindow:updateLeaderBoardPanelInfo(sort)
	for i = 1, self.btnInfos:getSize() do
		if sort == i then
			self.btnInfos[i].select = true;

			self.nameDesLab.text = self.btnInfos[i].titleone;
			self.jobDesLab.text = self.btnInfos[i].titletwo;
			self.fightDesLab.text = self.btnInfos[i].titlethree;
			DataCenter.LeaderBoardData:getleaderBoard(i, 0);
		else
			self.btnInfos[i].select = false;
		end
	end
	self.btnList:setLuaArrayData(self.btnInfos, false);

	if self.sort ~= sort then
		self.sort = sort;
		if self.curPanel == nil then
			self.curPanel = Lua_LeaderBoardPanel.new(self.content);
		end
	end
end

function Lua_LeaderBoardWindow:oneLeaderboardInfo()
	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end
	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil;
	end
	if self.monsEffect ~= nil then
		self.monsEffect:dispose();
		self.monsEffect = nil;
	end
	if self.effect ~= nil then
		self.effect:dispose();
		self.effect = nil;
	end
	self.loadedTime = 1;
	self.isLoadEffect = false;

	local LeaderBoardData = DataCenter.LeaderBoardData;
	if LeaderBoardData.isLeaderShow == false then
		self.mounterNum = LeaderBoardData.mounterid;
		self.mounterpos = LeaderBoardData.mounter_pos;
		self.mounterrot = LeaderBoardData.mounter_rot;
		self.mountersca = LeaderBoardData.mounter_sca;
		self.weapon = LeaderBoardData.weapon;
		self.roleId = LeaderBoardData.roleId;
		self.clothes = LeaderBoardData.clothes;
		self.fashion_weapon = LeaderBoardData.fashion_weapon;
		self.fashion_clothes = LeaderBoardData.fashion_clothes;
		self.magic_weapon = LeaderBoardData.magic_weapon;
		self.spoor_info = LeaderBoardData.spoor_info;
		self.top_wing_id = LeaderBoardData.top_wing_id;
		self.fairy_act = LeaderBoardData.fairy_act;
		self.ranktype = LeaderBoardData.ranktype;
		self.fashionHeadId = LeaderBoardData.fashionHeadId;

		if LeaderBoardData.mounterid == 0 then
			self:mode(LeaderBoardData.ranktype, LeaderBoardData.career);
		else
			self.floder = LeaderBoardData.floder;
			self.fileName = LeaderBoardData.fileName;
			self.modelName = LeaderBoardData.modelName;
			self.setmodelAngle = LeaderBoardData.setmodelAngle;

			self:UImode(LeaderBoardData.ranktype, LeaderBoardData.mounterid);
		end

		self.nameLab.text = LeaderBoardData.name;
		-- self.zhanLi.text = LanUtil.formateStr(LanUtil.getValue(110008), tostring(LeaderBoardData.force));
		self.zhanli.num = LeaderBoardData.force;
	else
		self.nameLab.text = LanUtil.getValue(120014);
		self.zhanli.num = 0;
		if self.sort == 1 or self.sort == 2 or self.sort == 12 or self.sort == 13 or self.sort == 14 or self.sort == 15 or self.sort == 16 or self.sort == 17 then
			self.weapon = DataCenter.roleData.weapon_id;
			self.roleId = DataCenter.roleData.roleId;
			self.clothes = DataCenter.roleData.clothes_id;
			self.fashion_weapon = DataCenter.roleData.fashion_weapon_id;
			self.fashion_clothes = DataCenter.roleData.fashion_clothes_id;
			self.magic_weapon = DataCenter.roleData.faqiId;
			self.spoor_info = DataCenter.roleData.spoorId;
			self.top_wing_id = DataCenter.roleData.wingId;
			self.fairy_act = DataCenter.roleData.fairyId;
			self.fashionHeadId = DataCenter.roleData.fashionHeadId;

			self:mode(self.sort, DataCenter.roleData.career);
		else
			LeaderBoardData:ismounterID(self.sort);

			self.mounterNum = LeaderBoardData.mounterid
			self.mounterpos = LeaderBoardData.mounter_pos;
			self.mounterrot = LeaderBoardData.mounter_rot;
			self.mountersca = LeaderBoardData.mounter_sca;
			self.floder = LeaderBoardData.floder;
			self.fileName = LeaderBoardData.fileName;
			self.modelName = LeaderBoardData.modelName;
			self.setmodelAngle = LeaderBoardData.setmodelAngle;

			self:UImode(self.sort, LeaderBoardData.fileName);
		end
	end

	Lua_CommonUtil.addTimer("onModelLoadedTime", 0.5, self, self.onModelLoadedTime);
	self:onModelLoadedTime();

	self.myRankLab.text = LeaderBoardData.mycurrank;
	self.myNameLab.text = LeaderBoardData.myname;
	self.myJobLab.text = LeaderBoardData.mymountername;
	self.myFightLab.text = LeaderBoardData.myrankvalue;

	if LeaderBoardData.myViplvl ~= nil then
		self.vipNum.num = LeaderBoardData.myViplvl;
	end
	-- self.myVIPLab.text = LeaderBoardData.myViplvl;
	
	self.vipIcon:setEnable(LeaderBoardData.myViplvl ~= nil);
	self.vipNum:setEnable(LeaderBoardData.myViplvl ~= nil);
end

function Lua_LeaderBoardWindow:mode(ranktype, career)
	-- if self.sort == 1 or self.sort == 2  or self.sort == 12 or self.sort == 13
		-- or self.sort == 14 or self.sort == 15 or self.sort == 16 then
		local modelData = UsData();
		modelData.roleId = self.roleId;
		modelData.weapon_id = self.weapon; -- 武器
		modelData.clothes_id = self.clothes; -- 衣服
		modelData.fashion_weapon_id = self.fashion_weapon;
		modelData.fashion_clothes_id = self.fashion_clothes;
		modelData.fashionHeadId = self.fashionHeadId;
		modelData.career = career; -- 职业
		modelData.wingId = self.top_wing_id; -- 仙羽等级
		-- modelData.profession = self.data.profession; -- 当前转职次数
		modelData.fairyId = self.fairy_act; -- 神兵等级
		modelData.faqiId = self.magic_weapon; -- 法宝
		modelData.spoorId = self.spoor_info; -- 足迹
		modelData.showShadow = false;
		modelData.canBeClick = false;
		modelData.isShowName = false;
		modelData.IsUI = true;
		modelData.hp = 1;
		modelData.kind = 1;

		self.playerModel = ModelPlayer();
		self.playerModel:init(self.content, Vector3(-145, -210, 500), Vector3(0, 90, 0), modelData, nil, 200);
		self.playerModel:addLuaLoadedCallBack(self, self.onModelLoaded);
		self.playerModel:SetRenderQueue(self.midBg, 10, 2);
		self.playerModel:setRotEnable(true, 0, 200, 900, 400, 3);

		Lua_CommonUtil.removeTimer(self, self.effectRoot);
	-- end

	-- 装扮背景
	if DataCenter.LeaderBoardData.fashionBgId ~= nil and DataCenter.LeaderBoardData.fashionBgId ~= 0 then
		local list = DataCenter.FashionData:getItem(DataCenter.LeaderBoardData.fashionBgId);
		if self.fashionBg == nil then
			self.fashionBg = UICreate.createImage(self.content, "/images/fashionBg/leaderBoard_"..list.id..".png", -143, -30, 0, 0);
			self.fashionBg.name = "fashionBg";
			self.fashionBg:setDepth(2);
		end
		if self.showEffect ~= nil then
			self.showEffect:dispose();
			self.showEffect = nil;
		end
		if self.showEffect == nil and list.effectName ~= nil then
			local offset = DataCenter.FashionData:getBgEffectOffset(list.id, "rank_offset");
			self.showEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/"..list.effectName, list.effectName, offset[1], offset[2]);
			self.showEffect:setScale(offset[4], offset[4], offset[4]);
			self.showEffect:SetRenderQueue(self.midBg, 10, 2, false);
		end
	else
		if self.fashionBg ~= nil then
			self.fashionBg:dispose();
			self.fashionBg = nil;
		end
		if self.showEffect ~= nil then
			self.showEffect:dispose();
			self.showEffect = nil;
		end
	end
end

function Lua_LeaderBoardWindow:onModelLoaded()
	self.isLoadEffect = true;
	if self.effect ~= nil then
		-- self.effect:setEnable(false);
		self.effect:dispose();
		self.effect = nil;
	end

	if self.modelTexture ~= nil then
		self.modelTexture:setEffectActive(true);
		if self.sort == 10 then
			self.modelTexture.uiEffect:setAction(1)
		end
	elseif self.monsEffect ~= nil then
		self.monsEffect:setEnable(true);
		self.monsEffect:setAction(0);
	end
end

function Lua_LeaderBoardWindow:UImode(ranktype, career)
	if self.fashionBg ~= nil then
		self.fashionBg:dispose();
		self.fashionBg = nil;
	end
	if self.showEffect ~= nil then
		self.showEffect:dispose();
		self.showEffect = nil;
	end

	local curModel = career;
	local effectUrl = self.floder .. "/" .. tostring(curModel);
	if (ranktype >= 5 and ranktype <= 7) or ranktype == 10 or ranktype == 11 then
		local imgPos = ranktype == 5 and Vector2(-80, -34) or Vector2(-157, -34);
		local imgSize = Vector2(1175, 680);
		local modelRot = Vector3(0, 180, 0);
		local modelOffset = Vector2(0, -406);

		self.modelTexture = UIModelTexture();
		self.modelTexture:init(self.content, imgPos, imgSize, 3, modelRot, modelOffset, 360);
		self.modelTexture:addLuaLoadedCallBack(self, self.onModelLoaded);
		self.modelTexture:setEffectActive(false);
		if ranktype == 5 or ranktype == 7 then
			self.modelTexture.uiEffect:setSacle(self.mountersca[1],self.mountersca[2],self.mountersca[3]);
			self.modelTexture:setRotEnable(true, -80, 0, 300, 400, 2)
		else
			self.modelTexture:setCamView(8);
			self.modelTexture:setRotEnable(true, 0, 0, 300, 400, 2);
			self.modelTexture:setImgSize(self.mountersca[1], self.mountersca[2]);
		end
		self.modelTexture:setModelOffset(self.mounterpos[1], self.mounterpos[2]);
		self.modelTexture:setEffectPos(self.setmodelAngle[1], self.setmodelAngle[2], self.setmodelAngle[3]);
		self.modelTexture:setModelAngle(self.mounterrot[1], self.mounterrot[2], self.mounterrot[3]);
		self.modelTexture:setUrl(self.floder .. "/" .. self.fileName, tostring(self.modelName));
	else
		self.monsEffect = UICreate.createUIEffect(self.content, nil, nil, 0, 0);
		self.monsEffect:addLuaLoadedCallBack(self, self.onModelLoaded);
		self.monsEffect:setEnable(false);
		self.monsEffect:setRotEnable(true, -140, -55, 300, 400, 3);
		self.monsEffect:SetRenderQueue(self.midBg, 1, 2);
		self.monsEffect:setRot(self.mounterrot[1], self.mounterrot[2], self.mounterrot[3]);
		self.monsEffect:setSacle(self.mountersca[1], self.mountersca[2], self.mountersca[3]);
		self.monsEffect:setLocation(self.mounterpos[1], self.mounterpos[2], self.mounterpos[3]);
		self.monsEffect:setUrl(self.floder .. "/" .. self.fileName, tostring(self.modelName));
	end

	if ranktype == 9 then
		Lua_CommonUtil.addTimer("effectRoot", 2, self, self.effectRoot);
	else
		Lua_CommonUtil.removeTimer(self, self.effectRoot);
	end
end

function Lua_LeaderBoardWindow:effectRoot()
	if self.monsEffect == nil then
		return;
	end

	local effectRoot = self.monsEffect.mainContent;
	if effectRoot ~= nil then
		effectRoot:SetActive(false);
		effectRoot:SetActive(true);
	end
end

function Lua_LeaderBoardWindow:onModelLoadedTime()
	if self.loadedTime > 0 then
		self.loadedTime = self.loadedTime - 1;
	else
		if self.isLoadEffect == false then
			self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_loadingring", "gui_loadingring", -143, -30);
			self.effect:SetRenderQueue(self.midBg, 20, 2, false);
		end
		Lua_CommonUtil.removeTimer(self, self.onModelLoadedTime);
	end
end

function Lua_LeaderBoardWindow:dispose()
	DataCenter.thingData:clearCloakTemp();
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end
	if self.monsEffect ~= nil then
		self.monsEffect:dispose();
		self.monsEffect = nil;
	end
	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil;
	end
	if self.fashionBg ~= nil then
		self.fashionBg:dispose();
		self.fashionBg = nil;
	end
	if self.showEffect ~= nil then
		self.showEffect:dispose();
		self.showEffect = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onModelLoadedTime);
	Lua_CommonUtil.removeTimer(self, self.effectRoot);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_btnListItem = class("Lua_btnListItem", Lua_ListCell);
function Lua_btnListItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_btnListItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemBg = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 0, 0);
	self.itemBg:setDepth(3);

	self.desLab = UICreate.createLabel(self.content, "", 0, 0, 200, 30, 30);
	self.desLab.pivot = UIWidget.Pivot.Center;
	self.desLab:setDepth(5);
end

function Lua_btnListItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if data.select == true then
		self.itemBg:setAltas("common_atlas_1", "ui_common_btn_p1");
		self.desLab.text = "[FFFFFF]" .. data.name .. LanUtil.getValue(120010);
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_btn_p2");
		self.desLab.text = "[D5DADE]" .. data.name .. LanUtil.getValue(120010);
	end
end

function Lua_btnListItem:onPlayerSoundClick(go)
	if data ~= nil then
		Lua_MsgUtil.callFunc("ON_LEADERBOARD_ITEM_CLICK", self._data.sort);
	end
end

function Lua_btnListItem:dispose()
	if self.itemBg ~= nil then
		self.itemBg:dispose();
		self.itemBg = nil;
	end
	if self.desLab ~= nil then
		self.desLab:dispose();
		self.desLab = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end