Lua_PlayerInfoTipsWindow = class("Lua_PlayerInfoTipsWindow", Lua_SecondSizeWindow);
function Lua_PlayerInfoTipsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_PlayerInfoTipsWindow";
	self.skinName = "PlayerInfoTipsWindow_skin";
	self.titleText = "玩家信息";
end

function Lua_PlayerInfoTipsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.roleBg = UICreate.createImage(self.content, "/images/role/ui_figure_bg_12.png", -217, -35, 0, 0);
	self.roleBg.name = "roleBg";
	self.roleBg:setDepth(5);

	self.zhanliNum = Lua_NumberImage.new(self.content);
	self.zhanliNum.numWidth = 12;
	self.zhanliNum:setDepth(6);
	self.zhanliNum:setLocation(-201, 135.5, 0);

	local itemImg;
	self.itemImgArr = Array();
	for i = 1, 6 do
		itemImg = Lua_ToolImage.new(self.content);
		itemImg.content.name = "ui_jyt_" .. i;
		itemImg.noCompare = true;
		itemImg:setDepth(6);
		itemImg:setLocation(-484, 184 - 88 * (i - 1));
		itemImg:setDefaultIcon("role_atlas", "ui_jyt_" .. i);
		self.itemImgArr:add(itemImg);
	end

	for i = 1, 6 do
		itemImg = Lua_ToolImage.new(self.content);
		itemImg.content.name = "ui_jyt_" .. (i + 6);
		itemImg.noCompare = true;
		itemImg:setDepth(6);
		itemImg:setLocation(50, -256 + 88 * (i - 1));
		itemImg:setDefaultIcon("role_atlas", "ui_jyt_" .. i + 6);
		self.itemImgArr:add(itemImg);
	end

	self.fairyBtn.clickScale = false;
	self.fairyBtn:addClickFuntion(self, self.onIcon1Click);
	self.wingBtn.clickScale = false;
	self.wingBtn:addClickFuntion(self, self.onIcon2Click);
end

function Lua_PlayerInfoTipsWindow:showWin(param)
	self.playerInfo = param;

	self:showOtherPlayerInfo();
end

function Lua_PlayerInfoTipsWindow:showOtherPlayerInfo()
	local mainMsg = self.playerInfo.msg;
	DataCenter.thingData:setCloakTemp(tonumber(mainMsg.role_id), mainMsg.cloak);

	self.modelData = UsData();
	self.modelData.career = mainMsg.career;
	self.modelData.roleId = tonumber(mainMsg.role_id);
	self.modelData.gender = 1;
	self.modelData.weapon_id = mainMsg.equip_list.weapon;
	self.modelData.clothes_id = mainMsg.equip_list.clothes;
	self.modelData.wingId = mainMsg.equip_list.wing_shape;
	self.modelData.fairyId = mainMsg.equip_list.fairy_act_shape;
	self.modelData.faqiId = mainMsg.equip_list.magic_weapon_shape;
	self.modelData.spoorId = mainMsg.equip_list.spoor_shape;
	self.modelData.fashion_weapon_id = mainMsg.fashion_weapon_id;
	self.modelData.fashion_clothes_id = mainMsg.fashion_clothes_id;
	self.modelData.fashionHeadId = mainMsg.fashion_headdress_id;
	self.modelData.nickname = "";
	self.modelData.hp = 1;
	self.modelData.kind = 1;
	self.modelData.isShowName = false;
	self.modelData.IsUI = true;

	self:updateModel();

	-- 装扮背景
	if mainMsg.fashion_background_id ~= nil and mainMsg.fashion_background_id ~= 0 then
		local list = DataCenter.FashionData:getItem(mainMsg.fashion_background_id);
		self.roleBg:setUrl("/images/fashionBg/roleTips_" .. list.id .. ".png");

		if list.effectName ~= nil then
			local offset = DataCenter.FashionData:getBgEffectOffset(list.id, "roleTips_offset");
			self.effectBg = UICreate.createUIEffect(self.content, "/effects/scsEffects/" .. list.effectName, list.effectName, offset[1], offset[2]);
			self.effectBg:setScale(offset[4], offset[4], offset[4]);
			self.effectBg:SetRenderQueue(self.bg, 10, 2, false);
		end
	end

	for i = 1, self.itemImgArr:getSize() do
		self.itemImgArr[i].data = self.playerInfo.parts[i];
	end

	if mainMsg.wing_id ~= nil and mainMsg.wing_id ~= 0 then
		local wingConfig = Lua_WingUtil.getItemData(mainMsg.wing_id);
		self.wingLvLab.text = wingConfig.rtDesc;
	else
		self.wingLvLab.text = "";
	end

	self.playerName.text = mainMsg.role_name;
	self.careerLable2.text = Lua_ThingDefine.getJobName(mainMsg.career, mainMsg.profession)
	self.zuiLable2.text = mainMsg.pk;
	self.lvlLable2.text = mainMsg.level;
	if mainMsg.league_name ~= "" then
		self.bangLable2.text = mainMsg.league_name;
	else
		self.bangLable2.text = LanUtil.getValue(120134);
	end
	self.zhanliNum.num = mainMsg.fight_force;
	self.hpLable2.text = mainMsg.max_blood;
	self.mpLable2.text = mainMsg.max_magic;
	self.attLable2.text = mainMsg.attack_low .. "-" .. mainMsg.attack;
	self.defLable2.text = mainMsg.defence;
	self.hitLable2.text = mainMsg.hit;
	self.dodLable2.text = mainMsg.avoid;
	self.critLable2.text = mainMsg.crit;
	self.touLable2.text = mainMsg.toughness;

	if tostring(mainMsg.partner_name) ~= "" then -- 伴侣信息
		self.banlvLable2.text = tostring(mainMsg.partner_name);
	else
		self.banlvLable2.text = LanUtil.getValue(120134);
	end

	self:updateFairyIcon();
	self:updateWingIcon();
end

function Lua_PlayerInfoTipsWindow:updateModel()
	if self.playerModel == nil then
		self.playerModel = ModelPlayer();
	end
	self.playerModel:init(self.content, Vector3(-217, -230, -300), Vector3(0, 90, 0), self.modelData, nil, 200);
	self.playerModel:setRotEnable(true, 0, 200, 450, 400, 2);
	self.playerModel:SetRenderQueue(self.zhanTai, 1, 2);
	-- self.playerModel:setActive(self.isModel);
end

function Lua_PlayerInfoTipsWindow:updateFairyIcon()
	local equipedFairyItem = self.playerInfo.equipedFairyItem;
	if equipedFairyItem == nil then
		self.icon1:setAltas("icon_atlas_1", "ui_icon_jingling2");
	else
		self.icon1:setAltas(equipedFairyItem.atlas, equipedFairyItem.referenceId);
		self.icon1:SetDimensions(76, 76);
		self.icon1:setLocation(-390, -244);
	end
end

function Lua_PlayerInfoTipsWindow:updateWingIcon()
	local equipedWingItem = self.playerInfo.equipedWingItem;
	if equipedWingItem == nil then
		self.icon2:setAltas("icon_atlas_1", "ui_icon_shenyi2");
	else
		self.icon2:setAltas(equipedWingItem.atlas, equipedWingItem.referenceId);
		self.icon2:SetDimensions(76, 76);
		self.icon2:setLocation(-44, -248);
	end
end

function Lua_PlayerInfoTipsWindow:onIcon1Click(go)
	local equipedFairyItem = self.playerInfo.equipedFairyItem;
	if equipedFairyItem ~= nil then
		Lua_WindowUtil.openWin("Lua_ItemEquDetailWindow", WinParam.ACTION_OPEN, { data = equipedFairyItem, isMarketSell = false, isShowBtns = false });
	end
end

function Lua_PlayerInfoTipsWindow:onIcon2Click(go)
	local equipedWingItem = self.playerInfo.equipedWingItem;
	if equipedWingItem ~= nil then
		Lua_WindowUtil.openWin("Lua_ItemEquDetailWindow", WinParam.ACTION_OPEN, { data = equipedWingItem, isMarketSell = false, isShowBtns = false });
	end
end

function Lua_PlayerInfoTipsWindow:dispose()
	if self.roleBg ~= nil then
		self.roleBg:dispose();
		self.roleBg = nil;
	end
	if self.zhanliNum ~= nil then
		self.zhanliNum:dispose();
		self.zhanliNum = nil;
	end
	if self.itemImgArr ~= nil then
		self.itemImgArr:dispose();
		self.itemImgArr:clear();
		self.itemImgArr = nil;
	end
	if self.effectBg ~= nil then
		self.effectBg:dispose();
		self.effectBg = nil;
	end
	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end
	DataCenter.thingData:clearCloakTemp();

	self:superCall("dispose");
end